//////////////////////////////////////////////////////////////////////////////////////////////////////////
////                                          fins_program.h                                          ////
////                                           version: 1.5                                           ////
////                                          date: 04/03/15                                          ////
////                                        author: ric Pairet                                       ////
////                                                                                                  ////
////  This program defines and configures the used hardware and serial port. Also it gives names to   ////
////  the different pins and values to some variables.                                                ////
//////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <16F1829.h>
#device adc=16

#PRIORITY int_TIMER2,int_TIMER0,int_RDA

#define FIRMWARE_VERSION "1.5"
#define ADDRESS_ID        116

#FUSES NOWDT                    //No Watch Dog Timer
#FUSES HS                       //High speed Osc (> 4mhz for PCM/PCH) (>10mhz for PCD)
#FUSES WDT_SW                   //No Watch Dog Timer, enabled in Software
#FUSES PROTECT                  //Code protected from reads
#FUSES NOBROWNOUT               //No brownout reset
#FUSES WRT                      //Program Memory Write Protected
#FUSES PLL_SW                   //4X HW PLL disabled, 4X PLL enabled/disabled in software
#FUSES NOSTVREN                 //Stack full/underflow will not cause reset
#FUSES NOLVP                    //No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O

#use delay(clock=11059200)

#ROM 0x2100 = { '1','2','3','4' }

#use FIXED_IO( B_outputs=PIN_B6 )
#use FIXED_IO( C_outputs=PIN_C7,PIN_C6 )
#define DIRECTION   PIN_B6
#define WATER_SENSOR   PIN_C0
#define SERVO_L   PIN_C6
#define SERVO_R   PIN_C7

//RS-485 flow control
#define RECEIVE               0
#define TRANSMIT              1

//Main state machine options
#define COMMAND         0
#define ADDRESS         1
#define PARAMETER1      2
#define PARAMETER2      3
#define CONTROL_BIT     4
#define CONFIRMATION    5
#define CONFIGURATION   6

//Configuration state machine options
#define MINL   0
#define ZERL   2
#define MAXL   4
#define RANL   6
#define MINR   8
#define ZERR   10
#define MAXR   12
#define RANR   14

#use rs232( baud=57600,parity=N,xmit=PIN_B7,rcv=PIN_B5,bits=8,stream=PORT1 )
